package com.yoho.opsmanager.common.util;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.common.collect.ImmutableList;

public class ClientUtil {
	
	private static final Logger logger = LoggerFactory.getLogger(ClientUtil.class);
	 //读取配置文件中的private key 配置
    private static final Map<String, String> privateKeyMap = new HashMap<>();
	
	public static String getSign(Map<String, String> reqParams) {

        //remove some reqParams
        ImmutableList list = ImmutableList.of("/api", "client_secret", "q", "debug_data");
        SortedMap<String, String> filtedMap = new TreeMap<>();
        for (Map.Entry<String, String> entry : reqParams.entrySet()) {
            String k = entry.getKey();
            if (!list.contains(k)) {
                filtedMap.put(k, entry.getValue());
            }
        }

        //put private
        String clientType = reqParams.get("client_type");
        String privateKey = privateKeyMap.get(clientType);
        filtedMap.put("private_key", privateKey);


        //string: k1=v1&k2=v2
        List<String> array = new LinkedList<>();
        for (Map.Entry<String, String> entry : filtedMap.entrySet()) {
            String pair = entry.getKey() + "=" + entry.getValue();
            array.add(pair.trim());
        }
        String signStr = String.join("&", array);

        logger.debug("md5 str is: {}", signStr);

        //sign md5
        String sign = MD5.md5(signStr);

        return sign.toLowerCase();

    }
	
	public static String getSignObject(Map<String, Object> reqParams) {

        //remove some reqParams
        ImmutableList<String> list = ImmutableList.of("/api", "client_secret", "q", "debug_data");
        SortedMap<String, String> filtedMap = new TreeMap<>();
        for (Map.Entry<String, Object> entry : reqParams.entrySet()) {
            String k = entry.getKey();
            if (!list.contains(k)) {
                filtedMap.put(k, String.valueOf(entry.getValue()));
            }
        }

        //string: k1=v1&k2=v2
        List<String> array = new LinkedList<>();
        for (Map.Entry<String, String> entry : filtedMap.entrySet()) {
            String pair = entry.getKey() + "=" + entry.getValue();
            array.add(pair.trim());
        }
        String signStr = String.join("&", array);
    //    System.out.print("-------------"+signStr);
        //sign md5
        String sign = MD5.md5(signStr);

        return sign.toLowerCase();

    }
}
