package com.yoho.opsmanager.dao;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

import okhttp3.OkHttpClient;
import org.influxdb.InfluxDB;
import org.influxdb.InfluxDBFactory;

import com.yoho.opsmanager.common.model.InfluxDBModel;

public class InluxDBSingle {

	private Map<String, InfluxDBModel> map;

	public void init() {
		map = new HashMap<String, InfluxDBModel>();
		int num = Integer.valueOf(nums);
		String[] namesArray = names.split(";");
		String[] ipsArray = ips.split(";");
		String[] usersArray = users.split(";");
		String[] pwdsArray = pwds.split(";");
		String[] connectTimeOutArray = connectTimeOut.split(";");
		String[] readTimeOutArray = readTimeOut.split(";");
		String[] writeTimeOutArray = writeTimeOut.split(";");


		InfluxDBModel influxDBModel = null;
		for (int i = 0; i < num; i++) {
			influxDBModel = new InfluxDBModel();
			influxDBModel.setName(namesArray[i]);
			influxDBModel.setIp(ipsArray[i]);
			influxDBModel.setUser(usersArray[i]);
			influxDBModel.setPwd(pwdsArray[i]);

			OkHttpClient.Builder builder = new OkHttpClient.Builder();
			builder.connectTimeout(Integer.valueOf(connectTimeOutArray[i]), TimeUnit.SECONDS);
			builder.readTimeout(Integer.valueOf(readTimeOutArray[i]), TimeUnit.SECONDS);
			builder.writeTimeout(Integer.valueOf(writeTimeOutArray[i]), TimeUnit.SECONDS);

			InfluxDB influxDB = InfluxDBFactory.connect(ipsArray[i],
					usersArray[i], pwdsArray[i],builder);
			influxDB.enableBatch(100, 30, TimeUnit.SECONDS);
			influxDBModel.setInfluxDB(influxDB);
			map.put(namesArray[i], influxDBModel);
		}
	}

	/**
	 * 通过服务器名获取数据库
	 * 
	 * @param name
	 * @return
	 */
	public InfluxDBModel getInfluxDBByName(String name) {
		return map.get(name);
	}

	/**
	 * 获取所有的数据源
	 * 
	 * @return
	 */
	public Map<String, InfluxDBModel> getInfluxDBs() {
		return map;
	}

	/**
	 * 获取所有的DB name，用于选择
	 * 
	 * @return
	 */
	public List<String> getDBNames() {
		List<String> list = new ArrayList<String>();
		list.add("aws");
		list.add("qcloud");
		return list;
	}

	private String nums;

	private String names;

	private String ips;

	private String users;

	private String pwds;

	private String connectTimeOut;

	private String readTimeOut;

	private String writeTimeOut;

	public String getNums() {
		return nums;
	}

	public void setNums(String nums) {
		this.nums = nums;
	}

	public String getNames() {
		return names;
	}

	public void setNames(String names) {
		this.names = names;
	}

	public String getIps() {
		return ips;
	}

	public void setIps(String ips) {
		this.ips = ips;
	}

	public String getUsers() {
		return users;
	}

	public void setUsers(String users) {
		this.users = users;
	}

	public String getPwds() {
		return pwds;
	}

	public void setPwds(String pwds) {
		this.pwds = pwds;
	}

	public String getConnectTimeOut() {
		return connectTimeOut;
	}

	public void setConnectTimeOut(String connectTimeOut) {
		this.connectTimeOut = connectTimeOut;
	}

	public String getReadTimeOut() {
		return readTimeOut;
	}

	public void setReadTimeOut(String readTimeOut) {
		this.readTimeOut = readTimeOut;
	}

	public String getWriteTimeOut() {
		return writeTimeOut;
	}

	public void setWriteTimeOut(String writeTimeOut) {
		this.writeTimeOut = writeTimeOut;
	}

}
