package com.yoho.opsmanager.dao.mapper;

import org.influxdb.dto.QueryResult;

public interface MonitorAlarmMapper {

	/**
	 * 插入支付回调告警信息
	 * @param influxDBName
	 * @param snsContent
	 */
	void insertAlarmMsg(String influxDBName, String alarmType, String snsContent, String alarmInfo, String sendStatus,String result);

	/**
	 * 查询type的tag-value
	 * @param influxDBName
	 * @return
	 */
	QueryResult selectTagValuesType(String influxDBName);

	/**
	 * 查询指定influxdb type的告警短信内容
	 * @param influxDBName
	 * @param type
	 * @return
	 */
	QueryResult selectAlarmMsg(String influxDBName, String type, int minute);

	/**
	 * 查询指定influxdb type的告警短信内容，并且指定offset
	 *
	 * @param influxDBName
	 * @param type
	 * @param limitCount
	 * @param offsetCount
	 * @return
	 */
	QueryResult selectAlarmMsgByPagination(String influxDBName, String type, int limitCount, int offsetCount);

	/**
	 * 查询指定influxdb type的告警短信内容，并且指定offset
	 *
	 * @param influxDBName
	 * @param limitCount
	 * @param offsetCount
	 * @return
	 */
	QueryResult selectAlarmMsgByPagination(String influxDBName, int limitCount, int offsetCount);

	/**
	 * 获取指定influxdb type的数据数量
	 * @param influxDBName
	 * @param type
	 * @return
	 */
	QueryResult selectAlarmMsgCount(String influxDBName, String type);

	/**
	 * 获取指定influxdb type的数据数量
	 * @param influxDBName
	 * @return
	 */
	QueryResult selectAlarmMsgCount(String influxDBName);
}
