package com.yoho.opsmanager.dao.mapper.impl;

import com.yoho.opsmanager.common.contants.DataBaseContants;
import com.yoho.opsmanager.common.contants.InfluxDBName;
import com.yoho.opsmanager.dao.mapper.ClientDnsMapper;
import org.influxdb.dto.BatchPoints;
import org.influxdb.dto.Point;
import org.influxdb.dto.QueryResult;
import org.springframework.stereotype.Service;

/**
 * Created by yoho on 2016/5/24.
 */
@Service("clientDnsMapper")
public class ClientDnsMapperImpl extends InfluxDBQuery implements ClientDnsMapper {

    @Override
    public void write(BatchPoints batchPoints) {
        inluxDBSingle.getInfluxDBByName(InfluxDBName.ALARM).getInfluxDB().write(batchPoints);
    }

    @Override
    public QueryResult getDataOneHour() {
        String command = "select count(appversion) from client_dns_data where time > now() - 1h group by domain,is_real,net,provider,province_code,city_code";
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_DNS_REPORT,
                "ClientDnsMapperImpl", "getDataOneHour");
    }

    @Override
    public void write(Point point) {
        inluxDBSingle.getInfluxDBByName(InfluxDBName.ALARM).getInfluxDB().write(DataBaseContants.YOMO_DNS_REPORT, "default", point);
    }

    @Override
    public QueryResult getDataToPage(int day, String group) {
        String command = "select sum(count) from \"one_month\".\"client_dns_hour\" where time > now() - " + day +
                "d group by is_real," + group;
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_DNS_REPORT,
                "ClientDnsMapperImpl", "getDataToPage");
    }

    @Override
    public QueryResult getDatail(int day, String group, String groupName, String value) {
        String command = "select sum(count) from \"one_month\".\"client_dns_hour\" where time > now() - " + day +
                "d and is_real = 'false' and " + groupName + "= '" + value + "' group by " + group;
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_DNS_REPORT,
                "ClientDnsMapperImpl", "getDataToPage");
    }

}
