package com.yoho.opsmanager.dao.mapper.impl;

import com.yoho.opsmanager.common.contants.DataBaseContants;
import com.yoho.opsmanager.common.contants.InfluxDBName;
import com.yoho.opsmanager.common.util.ClientReportUtil;
import com.yoho.opsmanager.dao.InluxDBSingle;
import com.yoho.opsmanager.dao.mapper.ClientReportMapper;
import org.influxdb.dto.BatchPoints;
import org.influxdb.dto.Point;
import org.influxdb.dto.Query;
import org.influxdb.dto.QueryResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by yoho on 2016/5/24.
 */
@Service("clientReportMapper")
public class ClientReportMapperImpl extends InfluxDBQuery implements ClientReportMapper {


    @Override
    public void write(BatchPoints batchPoints) {
        inluxDBSingle.getInfluxDBByName(InfluxDBName.ALARM).getInfluxDB().write(batchPoints);
    }

    @Override
    public void write(Point point) {
        inluxDBSingle.getInfluxDBByName(InfluxDBName.ALARM).getInfluxDB().write(DataBaseContants.YOMO_REPORT, "default", point);
    }

    @Override
    public void writeData(Point point) {
        inluxDBSingle.getInfluxDBByName(InfluxDBName.ALARM).getInfluxDB().write(DataBaseContants.YOHO_REPORT_DATA, "default", point);

    }

    @Override
    public QueryResult getYestodayCount() {
        String command = "select sum(count) from \"ten_day\".client_report_grafana where time < now() - 1d and time > now() - 1443m";
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_REPORT,
                "ClientReportMapperImpl", "getYestodayCount");
    }

    @Override
    public QueryResult selectReportByGroupI(String table, int miniute) {
        String command = "select count(et) from " + table +
                " where time > now() - " + miniute +
                "m group by ei,client";
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_REPORT,
                "ClientReportMapperImpl", "selectReportByGroupI");
    }

    @Override
    public QueryResult selectReportByGroupO(String table, int miniute) {
        String command = "select count(et) from " + table +
                " where time > now() - " + miniute +
                "m group by methodevent,client,ec";
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_REPORT,
                "ClientReportMapperImpl", "selectReportByGroupO");
    }

    @Override
    public QueryResult selectClientByGroup(String table, int miniute) {
        String command = "select count(net) from " + table +
                " where time > now() - " + miniute +
                "m group by av,client,dm,osv,et,exceptionType ";
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_REPORT,
                "ClientReportMapperImpl", "selectClientByGroup");
    }

    @Override
    public QueryResult selectByDay(String table) {
        String command = "select sum(exceptionCount),sum(udidCount) from \"ten_day\"." + table +
                " where time > now() - 1d" +
                " group by av,client,dm,osv,et,exceptionType";
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_REPORT,
                "ClientReportMapperImpl", "selectByDay");
    }

    @Override
    public QueryResult selectEffectUid(String table, String dm, String av, String client, String osv, String exceptionType) {
        String command = "select count(distinct(udid)) from " + table + " where client = '" + client + "' and av = '" + av + "' and dm = '" + dm + "' and exceptionType = '" + exceptionType + "' and osv = '" + osv + "' and time > now() - 1h";
        return query(InfluxDBName.ALARM, command, DataBaseContants.YOMO_REPORT,
                "ClientReportMapperImpl", "selectEffectUid");
    }

}
