package com.yoho.opsmanager.dao.mapper.impl;

import org.influxdb.dto.Query;
import org.influxdb.dto.QueryResult;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

import com.yoho.opsmanager.common.contants.DataBaseContants;
import com.yoho.opsmanager.dao.InluxDBSingle;

public class InfluxDBQuery {
	
	@Autowired
	protected InluxDBSingle inluxDBSingle;
	
	protected final Logger logger = LoggerFactory.getLogger(getClass());

	protected QueryResult query(String influxDBName, String command, String database,
								String className, String functionName){
		Query query = new Query(command, database);
		try {
			QueryResult queryResult = inluxDBSingle.getInfluxDBByName(influxDBName)
					.getInfluxDB().query(query);
			
			return queryResult;
		} catch (Exception e) {
			logger.error("error:{}, className:{}, functionName:{}, command: {}",
					e.toString(), className, functionName, command);
			return null;
		}
	}
	
	protected QueryResult queryJmx(String influxDBName, String command, String className, String functionName){
		Query query = new Query(command, DataBaseContants.YOMO_JMX); 
		try {
			QueryResult queryResult = inluxDBSingle.getInfluxDBByName(influxDBName)
					.getInfluxDB().query(query);
			
			return queryResult;
		} catch (Exception e) {
			logger.error( className + " | "+ functionName + " | error: " + e.toString());
			return null;
		}
	}
}
