package com.yoho.opsmanager.other;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by zhengyouwei on 2016/8/1.
 */
public class DnsIPs {

    private final Map<String, List<String>> map = new HashMap<String, List<String>>();

    public void setDnsIps(Map<String, Object> dnsipsMap) {
        List<Map<String, Object>> keys = (List<Map<String, Object>>) dnsipsMap.get("dnsips");
        for (Map<String, Object> one : keys) {
            String domain = String.valueOf(one.get("domain"));
            List list = (List) one.get("ips");
            List<String> local = new ArrayList<>();
            for(Object o : list){
                local.add(String.valueOf(o));
            }
            map.put(domain,local);
        }
    }

    public boolean isLocalIp(String domain,String ips){
        List<String> ipList = map.get(domain);
        String[] array = ips.split(",");
        for (String a : array){
            boolean result = false;
            for(String ip : ipList){
                if(a.startsWith(ip)){
                    result =  true;
                    break;
                }
            }
            if (!result){
                return false;
            }
        }
        return true;
    }

    public boolean hasDomain(String domain){
        return map.containsKey(domain);
    }

}
