package com.yoho.opsmanager.other.clientReport;

import com.yoho.opsmanager.common.model.ClientReport.ClientPatchModel;
import com.yoho.opsmanager.common.model.ClientReport.ClientReportErrorModel;
import com.yoho.opsmanager.common.util.ApplicationUtil;
import com.yoho.opsmanager.common.util.ClientPatchUtil;
import com.yoho.opsmanager.common.util.ClientReportUtil;
import com.yoho.opsmanager.common.util.ReportCount;
import com.yoho.opsmanager.dao.mapper.ClientReportMapper;
import com.yoho.opsmanager.redis.service.ClientReportRedis;
import org.apache.commons.lang.StringUtils;
import org.influxdb.dto.Point;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.concurrent.TimeUnit;

/**
 * Created by zhengyouwei on 2016/8/24.
 */
public class ClientPatchRunnable implements Runnable {

    private String _mlogs;

    private String client;

    private static Random random = new Random();

    private Logger log = LoggerFactory.getLogger(getClass());

    public ClientPatchRunnable(String _mlogs, String client) {
        this._mlogs = _mlogs;
        this.client = client;
    }

    @Override
    public void run() {
        ReportCount.getAndIncrement();
        List<ClientPatchModel> list = ClientPatchUtil.getPatchsFromReport(_mlogs, client);
        if (list.size() == 0) {
            return;
        }
        try {
            ClientReportMapper errorReportMapper = (ClientReportMapper) ApplicationUtil.getBean(ClientReportMapper.class);

            for (ClientPatchModel clientPatchModel : list) {
                Point.Builder buildData = Point.measurement(ClientPatchUtil.getTableName());
                Map<String, String> tag = new HashMap<>();
                tag.put("client", client);
                tag.put("osv", clientPatchModel.getOsv());
                tag.put("dm", clientPatchModel.getDm());
                tag.put("av", clientPatchModel.getAv());
                tag.put("patcht",clientPatchModel.getPatcht());
                //插入原始数据表
                for (Map.Entry<String, String> entry : tag.entrySet()) {
                    if (StringUtils.isBlank(entry.getValue())) {
                        tag.put(entry.getKey(),"null");
                    }
                }
                buildData.tag(tag);
                buildData.addField("uid", clientPatchModel.getUid());
                buildData.addField("patchv", clientPatchModel.getPatchv());
                buildData.time(System.currentTimeMillis() * 1000000 + random.nextInt(999999), TimeUnit.NANOSECONDS);
                errorReportMapper.writeData(buildData.build());
            }

        } catch (Exception e) {
            log.error("writePatchData~~", e.toString());
        }

    }


}
