package com.yoho.opsmanager.other.clientReport;

import com.yoho.opsmanager.common.model.ClientReport.ClientReportErrorModel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *  利用logback的方式一个小时生成一个文件, 然后用shell推送到cons
 * Created by zrow.li on 2017/4/20.
 */
public final class ReportCons {
    private static Logger logger = LoggerFactory.getLogger("appErrorLogger");
    public static void writer(ClientReportErrorModel model) {
        logger.info("{}\n", toFormatString(model));
    }


    private static String getHiveTimestamp(){
        final String PATTERN = "yyyy-MM-dd HH:mm:ss.SSS";
        return new SimpleDateFormat(PATTERN).format(new Date());
    }

    private static String getDay(){
        final String PATTERN = "yyyy-MM-dd";
        return new SimpleDateFormat(PATTERN).format(new Date());
    }

    private static String toFormatString(ClientReportErrorModel model) {
        String str = model.getTime() + '|'
                + model.getcId() + '|'
                + model.getBody() + '|'
                + model.getClient() + '|'
                + model.getEc() + '|'
                + model.getEi() + '|'
                + model.getEt() + '|'
                + model.getId() + '|'
                + model.getMethod() + '|'
                + model.getResponse() + '|'
                + model.getsId() + '|'
                + model.getTs() + '|'
                + model.getUid() + '|'
                + model.getTec() + '|'
                + model.getCts() + '|'
                + model.getMethodevent() + '|'
                + model.getIndex() + '|'
                + model.getOsv() + '|'
                + model.getDm() + '|'
                + model.getAv() + '|'
                + model.getNet() + '|'
                + model.getCa() + '|'
                + model.getSt() + '|'
                + model.getExceptionType() + '|'
                + model.getUdid() + '|'
                + System.currentTimeMillis() +  '|'
                + getHiveTimestamp() +  '|'
                + getDay();
        return str.replaceAll("\\s", " ");
    }



    public static void main(String[] args) {
        ClientReportErrorModel model = new ClientReportErrorModel();
        model.setUid("uid");
        model.setBody("test \n test\rrtest\ttest\t\ttest");
        System.out.println(ReportCons.toFormatString(model));
    }
}
