package com.yoho.opsmanager.other.ctrl;

import javax.servlet.http.HttpServletRequest;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URLDecoder;
import java.util.zip.GZIPInputStream;

/**
 *  读取消息中的ZIP流
 * Created by chunhua.zhang on 2017/5/24.
 */
final class ContentReaderHelper {

    /**
     * 从Http请求中读取数据，支持Gzip
     * @param request HTTP请求
     * @return String类型的数据
     */
    public static String  getContentFromHttpRequest(HttpServletRequest request) {
        try {
            String encoding = request.getHeader("Content-Encoding");
            String result;
            if ("gzip".equalsIgnoreCase(encoding)) {
                ByteArrayOutputStream out = new ByteArrayOutputStream();
                GZIPInputStream gunzip = new GZIPInputStream(request.getInputStream());
                byte[] buffer = new byte[256];
                int n;
                while ((n = gunzip.read(buffer)) >= 0) {
                    out.write(buffer, 0, n);
                }
                gunzip.close();
                out.close();
                result = URLDecoder.decode(out.toString(), "UTF-8");
            } else {
                BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(request.getInputStream()));
                StringBuilder stringBuilder = new StringBuilder();
                String data;
                while ((data = bufferedReader.readLine()) != null) {
                    stringBuilder.append(data);
                }
                bufferedReader.close();
                result = URLDecoder.decode(stringBuilder.toString(), "UTF-8");
            }
            if (!result.startsWith("_mlogs=")) {
                return null;
            }
            return result.substring(7);
        } catch (IOException e) {
         }
        return null;
    }
}
