package com.yoho.opsmanager.other.ctrl;

import com.yoho.opsmanager.other.handlder.AppReportProcessor;
import com.yoho.opsmanager.other.model.response.BaseRespone;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

import static com.yoho.opsmanager.other.handlder.AppReportProcessor.DeviceType.android;
import static com.yoho.opsmanager.other.handlder.AppReportProcessor.DeviceType.ios;

/**
 * @author zhengyouwei 2016年5月12日 下午1:49:55
 *
 * @author chunhua.zhang@yoho.cn
 */
@Controller
public class DataCollectionCtrl {

    @Autowired
    private AppReportProcessor processor;

    /**
     *  IOS 上报错误
     *
     * @return 2016年5月12日下午1:49:48
     */
    @RequestMapping(value = "ios_report")
    @ResponseBody
    public BaseRespone iosErrorData(HttpServletRequest request) {

        String _mlogs = ContentReaderHelper.getContentFromHttpRequest(request);
        if (StringUtils.isBlank(_mlogs)) {
            return BaseRespone.failResp("failed");
        }
        processor.submitError(_mlogs, ios);
        return BaseRespone.successResp(null);

    }


    /**
     *  Android 上报错误
     *
     * @return 2016年5月12日下午1:49:48
     */
    @RequestMapping(value = "android_report")
    @ResponseBody
    public BaseRespone androidErrorData(HttpServletRequest request) {

        String _mlogs = ContentReaderHelper.getContentFromHttpRequest(request);
        if (StringUtils.isBlank(_mlogs)) {
            return BaseRespone.failResp("failed");
        }
        processor.submitError(_mlogs, android);
        return BaseRespone.successResp(null);
    }

    /**
     * 上发patch
     *
     * @return 2016年5月12日下午1:49:48
     */
    @RequestMapping(value = "ios_patch_report")
    @ResponseBody
    public BaseRespone ios_patch_report(HttpServletRequest request) {

        String _mlogs = ContentReaderHelper.getContentFromHttpRequest(request);
        if (StringUtils.isBlank(_mlogs)) {
            return BaseRespone.failResp("failed");
        }
        processor.submitPatch(_mlogs, ios);
        return BaseRespone.successResp(null);

    }


    /**
     * 上发patch
     *
     * @return 2016年5月12日下午1:49:48
     */
    @RequestMapping(value = "android_patch_report")
    @ResponseBody
    public BaseRespone android_patch_report(HttpServletRequest request) {

        String _mlogs = ContentReaderHelper.getContentFromHttpRequest(request);
        if (StringUtils.isBlank(_mlogs)) {
            return BaseRespone.failResp("failed");
        }
        processor.submitPatch(_mlogs, android);
        return BaseRespone.successResp(null);
    }




}
