package com.yoho.opsmanager.other.ctrl;

import com.yoho.opsmanager.other.dns.DnsWriteRunnable;
import com.yoho.opsmanager.other.dns.ThreadPool;
import com.yoho.opsmanager.other.model.DnsRequest;
import com.yoho.opsmanager.other.model.response.BaseRespone;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.io.*;
import java.net.URLDecoder;
import java.util.zip.GZIPInputStream;

/**
 * @author zhengyouwei 2016年5月12日 下午1:49:55
 */
@Controller
public class DnsCollectionCtrl {
    Logger logger = LoggerFactory.getLogger(getClass());

    /**
     * 上发dns
     *
     * @return 2016年5月12日下午1:49:48
     */
    @RequestMapping(value = "android_dns_report")
    @ResponseBody
    public BaseRespone androidDnsData(HttpServletRequest request) throws UnsupportedEncodingException {
        String _mlogs = ContentReaderHelper.getContentFromHttpRequest(request);
        JSONObject json = getJson(_mlogs);
        if (json == null) {
            return BaseRespone.failResp("failed");
        }
        if (json.has("dnsdata")) {
            JSONArray array = json.getJSONArray("dnsdata");
            DnsRequest dnsRequest = new DnsRequest();
            dnsRequest.setClient("android");
            dnsRequest.setArray(array);
           //  DnsWriteRunnable dnsWriteRunnable = new DnsWriteRunnable(dnsRequest);
            //ThreadPool.run(dnsWriteRunnable);
        }
        return BaseRespone.successResp(null);
    }

    /**
     * 上发dns
     *
     * @return 2016年5月12日下午1:49:48
     */
    @RequestMapping(value = "ios_dns_report")
    @ResponseBody
    public BaseRespone iosDnsData(HttpServletRequest request) throws UnsupportedEncodingException {
        String _mlogs = ContentReaderHelper.getContentFromHttpRequest(request);
        JSONObject json = getJson(_mlogs);
        if (json == null) {
            return BaseRespone.failResp("failed");
        }
        if (json.has("dnsdata")) {
            JSONArray array = json.getJSONArray("dnsdata");
            DnsRequest dnsRequest = new DnsRequest();
            dnsRequest.setClient("ios");
            dnsRequest.setArray(array);
           // DnsWriteRunnable dnsWriteRunnable = new DnsWriteRunnable(dnsRequest);
           // ThreadPool.run(dnsWriteRunnable);
        }
        return BaseRespone.successResp(null);

    }

    public JSONObject getJson(String _mlogs) {
        try {
            return JSONObject.fromObject(_mlogs);

        } catch (Exception e) {
            return null;
        }
    }
}

