package com.yoho.opsmanager.other.grafana;

import lombok.Data;

/**
 * ref to: http://docs.grafana.org/alerting/notifications/
 * /**
 *
 * {
 "title": "My alert",
 "ruleId": 1,
 "ruleName": "Load peaking!",
 "ruleUrl": "http://url.to.grafana/db/dashboard/my_dashboard?panelId=2",
 "state": "alerting",
 "imageUrl": "http://s3.image.url",
 "message": "Load is peaking. Make sure the traffic is real and spin up more webfronts",
 "evalMatches": [
 {
 "metric": "requests",
 "tags": {},
 "value": 122
 }
 ]
 }
 *   Grafana告警
 * Created by chunhua.zhang on 2017/5/26.
 */
@Data
public class GrafanaAlert {

    private String title;
    private int ruleId;
    private String ruleName;
    private String ruleUrl;
    private String state;
    private String imageUrl;
    private String message;

    private EvalMatches evalMatches;


}
