package com.yoho.opsmanager.other.handlder;

import com.yoho.opsmanager.common.model.ClientReport.ClientReportErrorModel;
import com.yoho.opsmanager.common.util.ClientReportUtil;
import com.yoho.opsmanager.other.influxdb.InfluxDBWriter;
import org.apache.commons.collections.CollectionUtils;

import static com.yoho.opsmanager.other.handlder.AppReportProcessor.*;

import java.util.LinkedList;
import java.util.List;

/**
 *  客户端错误处理器
 * Created by chunhua.zhang on 2017/5/24.
 */
public class AppErrorReportHandler implements  Runnable {


    private List<ErrorInfoHolder> batchMsgs;
    private  InfluxDBWriter writer;
    public AppErrorReportHandler(InfluxDBWriter writer, List<ErrorInfoHolder> batchMsgs) {
        this.batchMsgs = batchMsgs;
        this.writer = writer;
    }

    @Override
    public void run() {
        if(CollectionUtils.isEmpty(batchMsgs)){
            return;
        }
        //将错误消息解析为模型
        List<ClientReportErrorModel> errors = new LinkedList<>();
        for(ErrorInfoHolder holder: batchMsgs){
            errors.addAll(ClientReportUtil.getErrorsFromReport(holder.msg, holder.deviceType.name()));
        }

        this.writer.doWrite(errors);
    }
}
