package com.yoho.opsmanager.task;

import com.yoho.opsmanager.common.config.AlarmConfig;
import com.yoho.opsmanager.task.service.ClientReportErrorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

@Component
public class ClientReportErrorTask {

    @Autowired
    private ClientReportErrorService clientReportErrorService;

    @Autowired
    private AlarmConfig alarmConfig;

    @Scheduled(cron = "${cron.client.countCheck}")
    public void errorCountMonitor() {
        try {
            clientReportErrorService.clentReportErrorMonitor(alarmConfig.getClientCheckPeriod(),alarmConfig.getClientCheckNumber());
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @Scheduled(cron = "${cron.task.influxdb.clientreport.write}")
    public void cleintCountInsert() {
        try {
            clientReportErrorService.clientErrorGroupInsert();
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @Scheduled(cron = "${cron.task.influxdb.client.hour}")
    public void cleintDmCountInsert() {
        try {
            clientReportErrorService.clientHourInsert();
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @Scheduled(cron = "${cron.task.influxdb.client.day}")
    public void cleintDayCountInsert() {
        try {
            clientReportErrorService.clientDayInsert();
        }catch (Exception e){
            e.printStackTrace();
        }
    }
}
